#!/bin/env python3

import matplotlib.pyplot as plt
import numpy as np
import io, os

tty_enum = os.popen('./get_tty_devs.sh').read().strip().split('\n')

psu_tty_dev = '/dev/' + next((a for a in tty_enum if a.find('KORAD') > 0), '').split(':')[0]

if psu_tty_dev != '/dev/':
    print('found PSU TTY device: ' + psu_tty_dev)
else:
    print('couldn\'t find PSU TTY device')
    exit()

tty = io.TextIOWrapper(io.FileIO(os.open(psu_tty_dev, os.O_NOCTTY | os.O_RDWR), "r+"))

def set_read(tty, cmd):
    tty.write(cmd + '\n')
    line = tty.readline()
    return(line.strip())

def set_noread(tty, cmd):
    tty.write(cmd + '\n')

print('Device code: ' + set_read(tty, '*IDN?'))
print()

set_noread(tty, 'VSET1:{:05.2f}'.format(12.0))
set_noread(tty, 'VSET2:{:05.2f}'.format(5.0))

print('VS1: ' + set_read(tty, 'VSET1?'))
print('IL1: ' + set_read(tty, 'ISET1?'))
print('V1: ' + set_read(tty, 'VOUT1?'))
print('I1: ' + set_read(tty, 'IOUT1?'))
print()

print('VS2: ' + set_read(tty, 'VSET2?'))
print('IL2: ' + set_read(tty, 'ISET2?'))
print('V2: ' + set_read(tty, 'VOUT2?'))
print('I2: ' + set_read(tty, 'IOUT2?'))

